Index: src/edu/ucsb/nceas/metacat/DocumentImpl.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 4080)
@@ -50,7 +50,12 @@
 import java.util.Vector;
 
 import edu.ucsb.nceas.dbadapter.AbstractDatabase;
+import edu.ucsb.nceas.metacat.service.PropertyService;
 import edu.ucsb.nceas.metacat.spatial.SpatialHarvester;
+import edu.ucsb.nceas.metacat.util.LDAPUtil;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+import edu.ucsb.nceas.metacat.util.SystemUtil;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 
 import org.apache.log4j.Logger;
 import org.xml.sax.ContentHandler;
@@ -90,15 +95,32 @@
     public static final String SCHEMAVALIDATIONFEATURE = "http://apache.org/xml/features/validation/schema";
     public static final String NAMESPACEFEATURE = "http://xml.org/sax/features/namespaces";
     public static final String NAMESPACEPREFIXESFEATURE = "http://xml.org/sax/features/namespace-prefixes";
-    public static final String EML2_1_0NAMESPACE = MetaCatUtil
-            .getOption("eml2_1_0namespace");
-    // "eml://ecoinformatics.org/eml-2.1.0";
-    public static final String EML2_0_1NAMESPACE = MetaCatUtil
-            .getOption("eml2_0_1namespace");
-    // "eml://ecoinformatics.org/eml-2.0.1";
-    public static final String EML2_0_0NAMESPACE = MetaCatUtil
-            .getOption("eml2_0_0namespace");
-    // "eml://ecoinformatics.org/eml-2.0.0";
+    
+    public static final String EML2_1_0NAMESPACE;
+    public static final String EML2_0_1NAMESPACE;
+    public static final String EML2_0_0NAMESPACE;
+    
+    static {
+    	String eml210NameSpace = null;
+    	String eml201NameSpace = null;
+    	String eml200NameSpace = null;
+    	try {
+    		eml210NameSpace = PropertyService.getProperty("eml2_1_0namespace");
+    		eml200NameSpace = PropertyService.getProperty("eml2_0_1namespace");
+    		eml201NameSpace = PropertyService.getProperty("eml2_0_0namespace");
+    	} catch (PropertyNotFoundException pnfe) {
+    		System.err.println("Could not get property in static block: " 
+					+ pnfe.getMessage());
+    	}
+        
+    	EML2_1_0NAMESPACE = eml210NameSpace;
+        // "eml://ecoinformatics.org/eml-2.1.0";
+        EML2_0_1NAMESPACE = eml201NameSpace;
+        // "eml://ecoinformatics.org/eml-2.0.1";
+        EML2_0_0NAMESPACE = eml200NameSpace;
+        // "eml://ecoinformatics.org/eml-2.0.0";
+    }
+     
     public static final String DOCNAME = "docname";
     public static final String PUBLICID = "publicid";
     public static final String SYSTEMID = "systemid";
@@ -635,7 +657,7 @@
         // local server has newer version, then notify the remote server
         else if (userSpecifyRev < revInDataBase && revInDataBase > 0) {
             throw new Exception("Local server: "
-                    + MetaCatUtil.getOption("server")
+                    + SystemUtil.getSecureServerURL()
                     + " has newer revision of doc: " + docid + "."
                     + revInDataBase + ". Please notify it.");
         }
@@ -714,7 +736,6 @@
             throws Exception
     {
         boolean flag = true;
-        //MetaCatUtil util = new MetaCatUtil();
         String docid = MetaCatUtil.getDocIdFromString(accnum);
         int rev = MetaCatUtil.getVersionFromString(accnum);
 
@@ -981,8 +1002,6 @@
             out = new PrintWriter(pw);
         }
 
-        MetaCatUtil util = new MetaCatUtil();
-
         // Here add code to handle subtree access control
         /*
          * PermissionController control = new PermissionController(docid);
@@ -1367,36 +1386,50 @@
                                          + sqle.getMessage());
             }
         } finally {
-            DBConnectionPool.returnDBConnection(dbConn, serialNumber);
-        }
-        double finish = System.currentTimeMillis()/1000;
-        logMetacat.info("The time for inserting is "+(finish - afterDelete));
-    	logMetacat.warn("BuildIndex complete for docid " + docid);
+			DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+		}
+		double finish = System.currentTimeMillis() / 1000;
+		logMetacat.info("The time for inserting is " + (finish - afterDelete));
+		logMetacat.warn("BuildIndex complete for docid " + docid);
 
-        // Adds the docid to the spatial data cache 
-        if ( MetaCatUtil.getOption("runSpatialOption").equals("true") ) {
-            SpatialHarvester spatialHarvester = new SpatialHarvester();
-            logMetacat.info(" --------- Attempting to update the spatial cache for docid " + docid );
-            spatialHarvester.addToUpdateQue(docid);
-            spatialHarvester.destroy();
-            logMetacat.info(" --------- Finish to update the spatial cache for docid " + docid );
+		// Adds the docid to the spatial data cache
+		try {
+			if (PropertyService.getProperty("runSpatialOption").equals("true")) {
+				SpatialHarvester spatialHarvester = new SpatialHarvester();
+				logMetacat.info(" --------- Attempting to update the spatial cache for docid "
+								+ docid);
+				spatialHarvester.addToUpdateQue(docid);
+				spatialHarvester.destroy();
+				logMetacat.info(" --------- Finish to update the spatial cache for docid "
+								+ docid);
+			}
+		} catch (PropertyNotFoundException pnfe) {
+			logMetacat.error("Could not get 'runSpatialOption' property.  Spatial " 
+					+ "cache not run for docid: " + docid + " : " + pnfe.getMessage());
+		}
+
+
 	}
-        
-    }
 
     /**
-     * Recurse up the parent node hierarchy and add each node to the
-     * hashmap of paths to be indexed.  Note: pathsForIndexing is a hash map of 
-     * paths
-     *
-     * @param records the set of records hashed by nodeId
-     * @param rootNodeId the id of the root element of the document
-     * @param leafNodeId the id of the leafNode being processed
-     * @param id the id of the current node to be processed
-     * @param children the string representation of all child nodes of this id
-     * @param pathList the hash to which paths are added
-     * @param nodedata the nodedata for the current node
-     */
+	 * Recurse up the parent node hierarchy and add each node to the hashmap of
+	 * paths to be indexed. Note: pathsForIndexing is a hash map of paths
+	 * 
+	 * @param records
+	 *            the set of records hashed by nodeId
+	 * @param rootNodeId
+	 *            the id of the root element of the document
+	 * @param leafNodeId
+	 *            the id of the leafNode being processed
+	 * @param id
+	 *            the id of the current node to be processed
+	 * @param children
+	 *            the string representation of all child nodes of this id
+	 * @param pathList
+	 *            the hash to which paths are added
+	 * @param nodedata
+	 *            the nodedata for the current node
+	 */
     private void traverseParents(HashMap records, long rootNodeId,
             long leafNodeId, long id,
             String children, HashMap pathList, HashMap pathsFoundForIndexing) {
@@ -1776,6 +1809,10 @@
                 tableHasRows = rs.next();
                 if (tableHasRows) {
                     this.system_id = rs.getString(1);
+                    // system id may not have server url on front.  Add it if not.
+                    if (!system_id.startsWith("http://")) {
+                    	system_id = SystemUtil.getServerURL() + system_id;
+                    }
                     this.validateType = rs.getString(2);
 
                 }
@@ -2001,7 +2038,7 @@
                 int thisrev = DBUtil.getLatestRevisionInDocumentTable(docid);
                 logMetacat.info("this revsion is: " + thisrev);
                 // Save the old document publicaccessentry in a backup table
-                String accNumber = docid+MetaCatUtil.getOption("accNumSeparator")+thisrev;
+                String accNumber = docid+PropertyService.getProperty("accNumSeparator")+thisrev;
                 thisdoc = new DocumentImpl(accNumber, false);
                 DocumentImpl.archiveDocAndNodesRevision(connection, docid, user, thisdoc);
                 logMetacat.info("after archiveDoc");
@@ -2015,8 +2052,8 @@
                     thisrev = rev;
                 }
                 logMetacat.info("final revsion is: " + thisrev);
-                boolean useXMLIndex = (new Boolean(MetaCatUtil
-                        .getOption("usexmlindex"))).booleanValue();
+                boolean useXMLIndex = (new Boolean(PropertyService
+                        .getProperty("usexmlindex"))).booleanValue();
                 if (useXMLIndex) {
                     logMetacat.info("before delete");
                     double start = System.currentTimeMillis()/1000;
@@ -2206,7 +2243,7 @@
             boolean needValidation) throws Exception
     {
         // NEW - WHEN CLIENT ALWAYS PROVIDE ACCESSION NUMBER INCLUDING REV IN IT
-        //MetaCatUtil util = new MetaCatUtil();
+
         logMetacat.info("conn usage count before writting: "
                 + conn.getUsageCount());
         AccessionNumber ac = new AccessionNumber(accnum, action);
@@ -2320,7 +2357,7 @@
         if (action.equals("UPDATE")) {
             // check for 'write' permission for 'user' to update this document
             if (!hasWritePermission(user, groups, accnum) 
-            		&& !MetaCatUtil.isAdministrator(user, groups)) {
+            		&& !LDAPUtil.isAdministrator(user, groups)) {
                 throw new Exception(
                     "User " + user
                     + " does not have permission to update XML Document #"
@@ -2389,7 +2426,7 @@
         ForceReplicationHandler frh = new ForceReplicationHandler(accnum,
                 action, true, null);
         // clear cache after inserting or updating a document
-        if (MetaCatUtil.getOption("query_cache_on").equals("true"))
+        if (PropertyService.getProperty("query_cache_on").equals("true"))
         {
           //System.out.println("the string stored into cache is "+ resultsetBuffer.toString());
      	   DBQuery.clearQueryResultCache();
@@ -2401,9 +2438,9 @@
     }
 
     
-    private static void addDocidToIndexingQueue(String docid, String rev){
+    private static void addDocidToIndexingQueue(String docid, String rev) throws PropertyNotFoundException {
         boolean useXMLIndex =
-            (new Boolean(MetaCatUtil.getOption("usexmlindex"))).booleanValue();
+            (new Boolean(PropertyService.getProperty("usexmlindex"))).booleanValue();
         if (useXMLIndex) {
             	IndexingQueue.getInstance().add(docid, rev);
         }
@@ -2576,7 +2613,7 @@
         }
         
         // clear cache after inserting or updating a document
-        if (MetaCatUtil.getOption("query_cache_on").equals("true"))
+        if (PropertyService.getProperty("query_cache_on").equals("true"))
         {
           //System.out.println("the string stored into cache is "+ resultsetBuffer.toString());
      	   DBQuery.clearQueryResultCache();
@@ -2594,7 +2631,7 @@
         PreparedStatement pstmt = null;
         String documenttype = getDocTypeFromDBForCurrentDocument(accnumber);
         try {
-            String packagedoctype = MetaCatUtil.getOption("packagedoctype");
+            String packagedoctype = PropertyService.getProperty("packagedoctype");
             Vector packagedoctypes = new Vector();
             packagedoctypes = MetaCatUtil.getOptionList(packagedoctype);
             String docIdWithoutRev = MetaCatUtil.getDocIdFromAccessionNumber(accnumber);
@@ -2624,7 +2661,7 @@
             // if it is an access file
             else if (documenttype != null
                     && MetaCatUtil.getOptionList(
-                            MetaCatUtil.getOption("accessdoctype")).contains(
+                            PropertyService.getProperty("accessdoctype")).contains(
                             documenttype)) {
                 dbconn = DBConnectionPool.getDBConnection(
                         "DocumentImpl.runRelationAndAccessHandeler");
@@ -2764,7 +2801,7 @@
             double start = System.currentTimeMillis()/1000;
             // check for 'write' permission for 'user' to delete this document
             if (!hasAllPermission(user, groups, accnum)) {
-                if(!MetaCatUtil.isAdministrator(user, groups)){
+                if(!LDAPUtil.isAdministrator(user, groups)){
                     throw new Exception(
                         "User " + user
                         + " does not have permission to delete XML Document #"
@@ -2778,8 +2815,8 @@
             double afterArchiveDocAndNode = System.currentTimeMillis()/1000;
             logMetacat.info("The time for archiveDocAndNodesRevision is "+(afterArchiveDocAndNode - start));
             // Now delete it from the xml_index table
-            boolean useXMLIndex = (new Boolean(MetaCatUtil
-                    .getOption("usexmlindex"))).booleanValue();
+            boolean useXMLIndex = (new Boolean(PropertyService
+                    .getProperty("usexmlindex"))).booleanValue();
 
 
 
@@ -2881,7 +2918,7 @@
             ForceReplicationHandler frh = new ForceReplicationHandler(
                              accnum, ForceReplicationHandler.DELETE, isXML, notifyServer);
             // clear cache after inserting or updating a document
-            if (MetaCatUtil.getOption("query_cache_on").equals("true"))
+            if (PropertyService.getProperty("query_cache_on").equals("true"))
             {
               //System.out.println("the string stored into cache is "+ resultsetBuffer.toString());
          	   DBQuery.clearQueryResultCache();
@@ -2987,7 +3024,7 @@
             EntityResolver eresolver;
             DTDHandler dtdhandler;
             // Get an instance of the parser
-            String parserName = MetaCatUtil.getOption("saxparser");
+            String parserName = PropertyService.getProperty("saxparser");
             parser = XMLReaderFactory.createXMLReader(parserName);
             if (ruleBase != null && ruleBase.equals(EML200)) {
                 logMetacat.warn("Using eml 2.0.0 parser");
@@ -3113,7 +3150,7 @@
 
         try {
             if (doc == null) {
-                String accNumber = docid + MetaCatUtil.getOption("accNumSeparator") +
+                String accNumber = docid + PropertyService.getProperty("accNumSeparator") +
                 DBUtil.getLatestRevisionInDocumentTable(docid);
                     doc = new DocumentImpl(accNumber);
             }
@@ -3375,7 +3412,6 @@
         int serverLocation = -2;
         DBConnection dbConn = null;
         int serialNumber = -1;
-        //MetaCatUtil util = new MetaCatUtil();
 
         //we should consider about local host too
         if (serverName.equals(MetaCatUtil.getLocalReplicationServerName())) {
@@ -3601,7 +3637,6 @@
             double startTime = System.currentTimeMillis();
 
             // Open a connection to the database
-            MetaCatUtil util = new MetaCatUtil();
 
             dbconn = DBConnectionPool.getDBConnection("DocumentImpl.main");
             serialNumber = dbconn.getCheckOutSerialNumber();
@@ -3791,7 +3826,6 @@
     {
         DBConnection dbconn = null;
         int serialNumber = -1;
-        //MetaCatUtil util = new MetaCatUtil();
         AccessionNumber ac;
         PreparedStatement pstmt = null;
         String action = null;
@@ -3826,7 +3860,6 @@
      */
     static private void deleteXMLNodes(DBConnection dbconn, long rootId) throws Exception
     {
-        //MetaCatUtil util = new MetaCatUtil();
         AccessionNumber ac;
         PreparedStatement pstmt = null;
         double start = System.currentTimeMillis()/1000;
Index: src/edu/ucsb/nceas/metacat/service/ServiceException.java
===================================================================
--- src/edu/ucsb/nceas/metacat/service/ServiceException.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/service/ServiceException.java	(revision 4080)
@@ -0,0 +1,46 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: An Exception thrown when an error occurs because an 
+ *             AccessionNumber was invalid or used incorrectly
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ *
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.service;
+
+/**
+ * Exception thrown when an error occurs in a configuration administrative
+ * class
+ */
+public class ServiceException extends Exception {
+	
+	private static final long serialVersionUID = -2982801310798091071L;
+
+	/**
+	 * Create a new AdminException.
+	 *
+	 * @param message The error or warning message.
+	 */
+	public ServiceException(String message) {
+		super(message);
+	}
+}

